//1,"fix204426.sc","fix204426.sc",1.01,SYSTEM
//Copyright (c) Sage sp. z o.o.. Wszelkie prawa zastrzeone.

string sql

sql += "ALTER PROCEDURE [fk].[fk_BO_OR_UsunZeroweKonta]\n"
sql += "@rokId [fk].[tRokID]\n"
sql += "AS\n"
sql += "DECLARE @id   tID\n"
sql += "DECLARE @synt tSyntetyka\n"
sql += "DECLARE @poz1 tPoziom\n"
sql += "DECLARE @poz2 tPoziom\n"
sql += "DECLARE @poz3 tPoziom\n"
sql += "DECLARE @poz4 tPoziom\n"
sql += "DECLARE @poz5 tPoziom\n"
sql += "    DECLARE curKONTA CURSOR FOR\n"
sql += "	select [id], [syntetyka], [poziom1], [poziom2], [poziom3], [poziom4], [poziom5]\n"
sql += "	from fk.[konta]\n"
sql += "	where [rokId] = @rokId\n"
sql += "		and [SaldoRW]=0 and [WNBO]=0 and [MABO]=0 and [Wn]=0 and [Ma]=0\n"
sql += "		and [WN1]=0  and [MA1]=0  and [WN2]=0  and [MA2]=0  and [WN3]=0  and [MA3]=0\n"
sql += "		and [WN4]=0  and [MA4]=0  and [WN5]=0  and [MA5]=0  and [WN6]=0  and [MA6]=0\n"
sql += "		and [WN7]=0  and [MA7]=0  and [WN8]=0  and [MA8]=0  and [WN9]=0  and [MA9]=0\n"
sql += "		and [WN10]=0 and [MA10]=0 and [WN11]=0 and [MA11]=0 and [WN12]=0 and [MA12]=0\n"
sql += "		and [WN13]=0 and [MA13]=0 and [WN14]=0 and [MA14]=0 and [WN15]=0 and [MA15]=0\n"
sql += "		and [WN16]=0 and [MA16]=0 and [WN17]=0 and [MA17]=0 and [WN18]=0 and [MA18]=0\n"
sql += "		and [WN19]=0 and [MA19]=0 and [WN20]=0 and [MA20]=0 and [WN21]=0 and [MA21]=0\n"
sql += "		and [WN22]=0 and [MA22]=0 and [WN23]=0 and [MA23]=0\n"
sql += "		and [WNPKR]=0 and [MAPKR]=0 and [WNOR]=0 and [MAOR]=0\n"
sql += "    OPEN curKONTA\n"
sql += "    FETCH NEXT FROM curKONTA INTO @id, @synt, @poz1, @poz2, @poz3, @poz4, @poz5\n"
sql += "    WHILE (@@FETCH_STATUS = 0)\n"
sql += "     BEGIN\n"
sql += "		-- jesli nie istnieje zaden zapis w ksigach \n"
sql += "		-- dla takiego zerowego konta - usuwamy je\n"
sql += "		IF NOT EXISTS ( SELECT z.[id]\n"
sql += "				FROM fk.[zapisy] z LEFT join FK.dokumenty d ON d.rokId = z.rokId AND z.dokument = d.id\n"
sql += "				WHERE z.[rokId]=@rokId\n"
sql += "					and [synt]=@synt and [poz1]=@poz1 and [poz2]=@poz2\n"
sql += "					and [poz3]=@poz3 and [poz4]=@poz4 and [poz5]=@poz5\n"
sql += "					and ISNULL (d.zrodlo, 0) = 0) -- sprawdzamy tylko ksigi (bufor i wzorce pomijamy)\n"
sql += "			DELETE FROM fk.[konta]\n"
sql += "			WHERE [rokId]=@rokId and [id]=@id\n"
sql += "      FETCH NEXT FROM curKONTA INTO @id, @synt, @poz1, @poz2, @poz3, @poz4, @poz5\n"
sql += "      END\n"
sql += "    CLOSE curKONTA\n"
sql += "    DEALLOCATE curKONTA\n"

dispatch cn = GetAdoConnection()
cn.execute(sql, 0, 0x80 + 0x01)

#include "cnv.sci"
#include "hfall.sci"
#include "programy.sci"
#include "upgraps.sci"

#include "log.sci"
logInit( false )
log( ( using "akt204426.sc: arg1=\"%s\", arg2=\"%s\", arg3=\"%s\" - BEGIN", arg1, arg2, KatalogFirmy() ) )

typWydruku = TYPWYDRUKU_GRAPH
setStrona( 1900, 0, 0 )
strona 70, 250, 70, 200

setFont( "tekst" )
nazwaRaportu = "Aktualizacja raportw akt204426"

#define NAZWAOPERACJI nazwaRaportu

int sub opis( int a_pie )
endsub

int sub podsumowanie( int a_ost )
endsub

ROKIDTYPE sub cnvcbGetRok()
	cnvcbGetRok = 0
endsub

int sub cnvcbGetTabela()
	cnvcbGetTabela = BFI_SYSPROG
endsub

string sub cnvcbGetOperacja()
	cnvcbGetOperacja = NAZWAOPERACJI
endsub

bool sub UaktualnijRaportZPliku(string sFile)
	PRGERRTYPE pe
	pe = prgAdd( sFile )
	if !pe then
		print using "Baz raportw firmy zaktualizowano plikiem \"%s\".\n", sFile
		UaktualnijRaportZPliku = true
	endif
	if PRGERR_EXISTS == pe then
		print using "Plik \"%s\" zosta pominity, poniewa firma zawiera aktualn wersj tego raportu.\n", sFile
		pe = 0
		UaktualnijRaportZPliku = true
	endif
	if pe then
		print using "Bd %d podczas aktualizacji raportw plikiem \"%s\".\n", pe, sFile
		UaktualnijRaportZPliku = false
	endif
endsub

header( 1 )

string sPath
sPath = Katalog() + "raporty\\cnv\\"

// tu jest klu raportu, aktualizujemy wyspecyfikowane raporty (zapakowane w .amb eby si nie uruchamiay)
// wrzucanie ich w raporty\fk spowoduje konieczno usunicia po wprowadzeniu aktualizacji raportw na wzr innych moduw(??)
bool bSuccess =             UaktualnijRaportZPliku( sPath + "propvat.sc.amb" )
// koniec clue, reszta to kapsuka

//Ponisze odkomentowywa tylko do testw (eby si wykonanie w historii nie zapisywao).
//Wtedy pojawi si komunikat o bdzie wykonania, i okno wydruku nie jest zamykane.
//W oknie wydruku mona obejrze list aktualizowanych raportw i status operacji dla kadego aktualizowanego raportu.
//bSuccess = false

string s
log( ( using "bSuccess: %d", bSuccess ) )
if bSuccess then
	s = "Zaktualizowano baz raportw."
else
	s = "Bd aktualizacji bazy raportw do wersji."
endif
print s
log( s )

footer( 1 )

// w przypadku sukcesu, czytelne oznaczenie e akcja si wykonaa, w History.
// w przypadku bdu, ustawienie BUF, spowoduje e raport wykona si przy kolejnym wejciu.
cnvSetReportStatus( bSuccess, NAZWAOPERACJI, NAZWAOPERACJI )

log( ( "akt204426.sc - END" ) )
logDone()
close

